# Releases

A release consists of:

- A full set of binaries for all supported platforms, compiled from the same
  source.
- A text file containing hashes of each binary.
- A file containing a signature of the hash file, created by whoever is building
  the release.

## Building

*NOTE: This has only been tested from an x86_64 linux machine*

To create a release only a functional nix installation is required. Simply run
the `./release.sh` script, and input a release name when prompted.

From here an `isle` binary will be cross-compiled for all supported
platforms. This will take a long time the first time you perform it on your
machine.

Once compilation is completely, the release will be signed using the default GPG
key on your machine, and you will be prompted for its password in order to
create the signature.

## Releasing

Releases are uploaded to the repository's Releases page, and release naming
follows the conventional semantic versioning system. Each release should be
accompanied by a set of changes which have occurred since the last release,
described both in the `CHANGELOG.md` file and in the description on the Release
itself.
