# Creating a daemon.yml File

The `isle daemon` process has generally sane defaults and does not need
to be configured for most users. This document describes how to use the
`daemon.yml` file to handle those cases where configuration is necessary.

## Create daemon.yml

First, create a `daemon.yml` file. You can create a new `daemon.yml` with
default values filled in by doing:

```
isle daemon --dump-config > /path/to/daemon.yml
```

If you open that file in a text editor you can view all default values that
`isle daemon` ships with, as well as documentation for all configurable
parameters. Feel free to edit this file as needed.

## Using daemon.yml

With the `daemon.yml` created and configured, you can configure your daemon
process to use it by passing it as the `--config-path` argument:

```
sudo isle daemon --config-path /path/to/daemon.yml
```

If you are an operator then your host should be running its `isle daemon`
process in systemd (see [Getting Started](getting-started.md) if
not), and you will need to modify the service file accordingly.

