rec {

  version = "0.8.1";

  src = builtins.fetchGit {
    name = "garage-v${version}";
    url = "https://git.deuxfleurs.fr/Deuxfleurs/garage.git";
    rev = "76230f20282e73a5a5afa33af68152acaf732cf5";
  };

  package = {
    pkgsSrc,
    buildSystem,
    hostSystem,
  }: let

    compile = (import "${src}/nix/compile.nix") {

      system = buildSystem;
      target = hostSystem;
      pkgsSrc = pkgsSrc;

      cargo2nixOverlay = (import "${src}/nix/common.nix").cargo2nixOverlay;

      release = true;
      git_version = version;
    };

  in
    compile.workspace.garage {
      compileMode = "build";
    };
}
